﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace CheckBoxCellXAML
{
    public class UserDataItem : INotifyPropertyChanged
    {

        private static List<string> _groups = new List<string>() { "A", "B", "C", "D", "E" };
        private static ObservableCollection<UserDataItem> _dataItems = new ObservableCollection<UserDataItem>();
        public event PropertyChangedEventHandler PropertyChanged;
        private bool? _checked;
        private int _sno;
        private string _group;

        public int Sno
        {
            get
            {
                return _sno;
            }
            set
            {
                _sno = value;
                NotifyPropertyChanged();
            }
        }
        public string Group
        {
            get
            {
                return _group;
            }
            set
            {
                _group = value;
                NotifyPropertyChanged();
            }
        }

        public bool? Check
        {
            get
            {
                return _checked;
            }
            set
            {
                _checked = value;
                NotifyPropertyChanged();
            }
        }

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        public static ObservableCollection<UserDataItem> GetDataItems(int count)
        {
            var random = new Random();
            for (int i = 0; i < count; i++)
            {
                UserDataItem dataItem = new UserDataItem();
                dataItem.Sno = i;
                dataItem.Group = _groups[random.Next() % _groups.Count];
                dataItem.Check = i % 3 == 0 ? true : false;
                _dataItems.Add(dataItem);
            }
            return _dataItems;
        }
    }
}
